//
//  Square.c
//  fornax2_core
//
//  Created by Anders on 26.06.2018.
//  Copyright © 2018 Avividi. All rights reserved.
//
#include <string.h>
#include "strings.h"
#include "square.h"
#include "../genericutils/require.h"

square square_from_file (char file) {
  if (file == 'a') return 0;
  if (file == 'b') return 1;
  if (file == 'c') return 2;
  if (file == 'd') return 3;
  if (file == 'e') return 4;
  if (file == 'f') return 5;
  if (file == 'g') return 6;
  if (file == 'h') return 7;
//  require(0, "illegal uci file: %c", file);
  return -1;
}
square square_from_rank (char rank) {
  if (rank == '1') return 0;
  if (rank == '2') return 1;
  if (rank == '3') return 2;
  if (rank == '4') return 3;
  if (rank == '5') return 4;
  if (rank == '6') return 5;
  if (rank == '7') return 6;
  if (rank == '8') return 7;
//  require(0, "illegal uci rank: %c", rank);
  return -1;
}

char square_to_file(const Square square) {
  switch (square.x) {
    case 0: return 'a';
    case 1: return 'b';
    case 2: return 'c';
    case 3: return 'd';
    case 4: return 'e';
    case 5: return 'f';
    case 6: return 'g';
    case 7: return 'h';
    default:
      return '?';
  }
}

char square_to_uci_rank(const Square square) {
  return '0' + square.y + 1;
}


inhabitant square_piece_from_symbol(const char symbol) {
  switch (symbol) {
    case 'r': return INHABITANT_ROOKS;
    case 'n': return INHABITANT_KNIGHTS;
    case 'b': return INHABITANT_BISHOPS;
    case 'q': return INHABITANT_QUEENS;
    case 'k': return INHABITANT_KINGS;
    case 'p': return INHABITANT_PAWNS;
    default: return -1;
  }
}

Square square_from_uci(const char* uciSquare) {
  Square sq;
  long length = strlen(uciSquare);
  require(length == 2, "illegal uci square: %s", uciSquare);
  
  sq.x = square_from_file(uciSquare[0]);
  sq.y = square_from_rank(uciSquare[1]);
  
  return sq;
}


