//
//  Square.h
//  fornax2_core
//
//  Created by Anders on 26.06.2018.
//  Copyright © 2018 Avividi. All rights reserved.
//

#ifndef square_h
#define square_h

#include "definitions.h"

#define SQUARE_FLATTEN(x, y) (x + (y << 3))
#define SQUARE_INBOUNDS(position) (position >= 0 && position < 64)
#define SQUARE_X(position) (position & 7)
#define SQUARE_Y(position) (position / 8)

static inline square Square_flatten(const Square square) {
  return square.x + square.y * 8;
}

static inline bool Square_inBounds(const Square square) {
  return square.x >= 0 && square.x < 8 && square.y >= 0 && square.y < 8;
}

static inline Square Square_unflatten(const square position) {
  Square square = {position & 7, position / 8};
  return square;
}

static inline Square Square_add(const Square sq1, const Square sq2) {
  Square sum = {sq1.x + sq2.x, + sq1.y + sq2.y};
  return sum;
}
static inline bool Square_isOverflow(const square position) {
  return position > 63 || position < 0;
}

square square_from_rank (char rank);
square square_from_file (char rank);
Square square_from_uci(const char* uciSquare);
char square_to_file(const Square square);
char square_to_uci_rank(const Square square);
inhabitant square_piece_from_symbol(const char symbol);

#endif /* square_h */
