//
//  eval.c
//  fornax2_core
//
//  Created by Anders on 28/04/2019.
//  Copyright © 2019 Avividi. All rights reserved.
//


#include "eval.h"
#include "../board/definitions.h"
#include "../board/bitboard.h"
#include "../eval/eval_definitions.h"

eval eval_simple(const Board* board) {
  
  const bitboard64* friendlies = board->friendly->pieces;
  const bitboard64* hostiles = board->hostile->pieces;

  eval count = 0;
  count += BITBOARD_COUNT(friendlies[INHABITANT_KNIGHTS]) * PIECEVALUE_KNIGHTS;
  count += BITBOARD_COUNT(friendlies[INHABITANT_ROOKS]) * PIECEVALUE_ROOKS;
  count += BITBOARD_COUNT(friendlies[INHABITANT_BISHOPS]) * PIECEVALUE_BISHOPS;
  count += BITBOARD_COUNT(friendlies[INHABITANT_QUEENS]) * PIECEVALUE_QUEENS;
  count += BITBOARD_COUNT(friendlies[INHABITANT_PAWNS]) * PIECEVALUE_PAWNS;
  count -= BITBOARD_COUNT(hostiles[INHABITANT_KNIGHTS]) * PIECEVALUE_KNIGHTS;
  count -= BITBOARD_COUNT(hostiles[INHABITANT_ROOKS]) * PIECEVALUE_ROOKS;
  count -= BITBOARD_COUNT(hostiles[INHABITANT_BISHOPS]) * PIECEVALUE_BISHOPS;
  count -= BITBOARD_COUNT(hostiles[INHABITANT_QUEENS]) * PIECEVALUE_QUEENS;
  count -= BITBOARD_COUNT(hostiles[INHABITANT_PAWNS]) * PIECEVALUE_PAWNS;
  
  return count;
}

#define EVAL_EVALUATE eval_evaluate
#include "eval_innner.inc.h"
#undef EVAL_EVALUATE
