//
//  eval_definitions.h
//  fornax2_core
//
//  Created by Anders on 18/04/2020.
//  Copyright © 2020 Avividi. All rights reserved.
//

#ifndef eval_definitions_h
#define eval_definitions_h

#include "../board/definitions.h"

#define EVAL_NONE INT16_MIN
#define EVAL_CHECKMATE -10000
#define EVAL_ALPHASTART -12345
#define EVAL_DRAW 0
#define EVAL_BETASTART 12345

#define PIECEVALUE_KINGS 0
#define PIECEVALUE_PAWNS 100
#define PIECEVALUE_KNIGHTS 315
#define PIECEVALUE_BISHOPS 320
#define PIECEVALUE_ROOKS 510
#define PIECEVALUE_QUEENS 940
static const eval PIECEVALUE[6] = {
  PIECEVALUE_KINGS,
  PIECEVALUE_PAWNS,
  PIECEVALUE_KNIGHTS,
  PIECEVALUE_BISHOPS,
  PIECEVALUE_ROOKS,
  PIECEVALUE_QUEENS,
};

#define MATERIAL_VALUE_INITIAL ((\
PIECEVALUE_QUEENS\
+ PIECEVALUE_ROOKS * 2\
+ PIECEVALUE_BISHOPS * 2\
+ PIECEVALUE_KNIGHTS * 2\
+ PIECEVALUE_PAWNS * 8) * 2)

#define MATERIAL_VALUE_NULL_THRESHOLD 500
#define MATERIAL_VALUE_EXTEND_CHECK_THRESHOLD 1000

#define MOVE_PIECEVALUE_KINGS 0
#define MOVE_PIECEVALUE_PAWNS 7
#define MOVE_PIECEVALUE_KNIGHTS 20
#define MOVE_PIECEVALUE_BISHOPS 21
#define MOVE_PIECEVALUE_ROOKS 35
#define MOVE_PIECEVALUE_QUEENS 61
#define MOVE_PIECEVALUE_NONE (-MOVE_PIECEVALUE_QUEENS / 2)

#define MOVE_PROMOTIONVALUE_KNIGHTS MOVE_PIECEVALUE_KNIGHTS - MOVE_PIECEVALUE_PAWNS
#define MOVE_PROMOTIONVALUE_BISHOPS MOVE_PIECEVALUE_BISHOPS - MOVE_PIECEVALUE_PAWNS
#define MOVE_PROMOTIONVALUE_ROOKS MOVE_PIECEVALUE_ROOKS - MOVE_PIECEVALUE_PAWNS
#define MOVE_PROMOTIONVALUE_QUEENS MOVE_PIECEVALUE_QUEENS - MOVE_PIECEVALUE_PAWNS

#define MOVE_KILLER_STORE_THRESHOLD (MOVE_PIECEVALUE_NONE + MOVE_PIECEVALUE_PAWNS + 2)
#define MOVE_KILLER_VALUE -MOVE_PIECEVALUE_NONE
#define MOVE_BASEVALUE MOVE_PIECEVALUE_NONE

static const int8_t MOVE_CAPTUREVALUE[6] = {
  MOVE_PIECEVALUE_NONE,
  MOVE_PIECEVALUE_PAWNS,
  MOVE_PIECEVALUE_KNIGHTS,
  MOVE_PIECEVALUE_BISHOPS,
  MOVE_PIECEVALUE_ROOKS,
  MOVE_PIECEVALUE_QUEENS,
};

static const int8_t MOVE_PIECEVALUE[6] = {
  MOVE_PIECEVALUE_KINGS,
  MOVE_PIECEVALUE_PAWNS,
  MOVE_PIECEVALUE_KNIGHTS,
  MOVE_PIECEVALUE_BISHOPS,
  MOVE_PIECEVALUE_ROOKS,
  MOVE_PIECEVALUE_QUEENS,
};

//used to calculate game phase
#define PHASEVALUE_KINGS 0
#define PHASEVALUE_PAWNS 1
#define PHASEVALUE_KNIGHTS 9
#define PHASEVALUE_BISHOPS 9
#define PHASEVALUE_ROOKS 18
#define PHASEVALUE_QUEENS 48
static const uint8_t PHASEVALUE[6] = {
  PHASEVALUE_KINGS,
  PHASEVALUE_PAWNS,
  PHASEVALUE_KNIGHTS,
  PHASEVALUE_BISHOPS,
  PHASEVALUE_ROOKS,
  PHASEVALUE_QUEENS,
};
#define PHASEVALUE_INITIAL (\
PHASEVALUE_QUEENS\
+ PHASEVALUE_ROOKS * 2\
+ PHASEVALUE_BISHOPS * 2\
+ PHASEVALUE_KNIGHTS * 2\
+ PHASEVALUE_PAWNS * 8)

//used to adjust piece attack counts
#define ACTIVITYVALUE_KINGS 1
#define ACTIVITYVALUE_PAWNS 3
#define ACTIVITYVALUE_KNIGHTS 4
#define ACTIVITYVALUE_BISHOPS 4
#define ACTIVITYVALUE_ROOKS 2
#define ACTIVITYVALUE_QUEENS 1
static const int ACTIVITYVALUE[6] = {
  ACTIVITYVALUE_KINGS,
  ACTIVITYVALUE_PAWNS,
  ACTIVITYVALUE_KNIGHTS,
  ACTIVITYVALUE_BISHOPS,
  ACTIVITYVALUE_ROOKS,
  ACTIVITYVALUE_QUEENS
};


//used to adjust piece threat counts
#define THREATVALUE_KINGS 20
#define THREATVALUE_PAWNS 1
#define THREATVALUE_KNIGHTS 3
#define THREATVALUE_BISHOPS 3
#define THREATVALUE_ROOKS 5
#define THREATVALUE_QUEENS 9
static const int THREATVALUE[6] = {
  THREATVALUE_KINGS,
  THREATVALUE_PAWNS,
  THREATVALUE_KNIGHTS,
  THREATVALUE_BISHOPS,
  THREATVALUE_ROOKS,
  THREATVALUE_QUEENS
};

#endif /* eval_definitions_h */
