//
//  debugprint.h
//  fornax2_core
//
//  Created by Anders on 29/06/2019.
//  Copyright © 2019 Avividi. All rights reserved.
//

/*
 The do { ... } while (0) idiom ensures that the code acts like a statement (function call).
 The unconditional use of the code ensures that the compiler always checks that the debug code is valid
 — but the optimizer will remove the code when DEBUG is 0.
 */

#ifndef debugprint_h
#define debugprint_h

#define debug_print_l1(...) \
do { if (DEBUG) fprintf(stderr, __VA_ARGS__); } while (0)

#define debug_print_l2(...) \
do { if (DEBUG == 2) fprintf(stderr, __VA_ARGS__); } while (0)

#endif /* debugprint_h */
