//
//  iolog.c
//  fornax2_core
//
//  Created by Anders on 18/03/2020.
//  Copyright © 2020 Avividi. All rights reserved.
//

#include "iolog.h"
#include <stdarg.h>
#include <stdio.h>

#ifdef IO_LOG_ENABLED
static FILE *logfile;
#endif

void iolog_check_init() {
  #ifdef IO_LOG_ENABLED
  if (logfile == NULL) {
    logfile = fopen("io.log", "w+");
    fclose(logfile);
    logfile = fopen("io.log", "a+");
  }
  #endif
}
__attribute__((__format__ (__printf__, 1, 0)))
void iolog_printf(const char * c, ...) {
  iolog_check_init();
  va_list args;
  va_start(args, c);
  vprintf(c, args);
  va_end(args);
  
  
  #ifdef IO_LOG_ENABLED
  va_start(args, c);
  vfprintf(logfile, c, args);
  va_end(args);
  #endif
}

void iolog_fgets(char * c, int size) {
  iolog_check_init();
  
  (void)fgets(c, size, stdin);
  
  #ifdef IO_LOG_ENABLED
  fputs("> ", logfile);
  fputs(c, logfile);
  fflush(logfile);
  #endif
}

void iolog_flush() {
  iolog_check_init();
  fflush(stdout);
  
  #ifdef IO_LOG_ENABLED
  fflush(logfile);
  #endif
}
