//
//  stopwatch.c
//  fornax2_core
//
//  Created by Anders on 28/04/2019.
//  Copyright © 2019 Avividi. All rights reserved.
//

#include "stopwatch.h"

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <time.h>

static long wall_start;
static time_t cpu_start;


long stopwatch_wall_start_instance(void) {
  struct timeval timecheck;
  gettimeofday(&timecheck, NULL);
  return (long)timecheck.tv_sec * 1000 + (long)timecheck.tv_usec / 1000;
}

long stopwatch_wall_stop_instance(long start) {
  struct timeval timecheck;
  gettimeofday(&timecheck, NULL);
  long end = (long)timecheck.tv_sec * 1000 + (long)timecheck.tv_usec / 1000;
  return end - start;
}

void stopwatch_wall_start(void) {
  struct timeval timecheck;
  gettimeofday(&timecheck, NULL);
  wall_start = (long)timecheck.tv_sec * 1000 + (long)timecheck.tv_usec / 1000;
}
long stopwatch_wall_stop(void) {
  
  struct timeval timecheck;
  gettimeofday(&timecheck, NULL);
  long end = (long)timecheck.tv_sec * 1000 + (long)timecheck.tv_usec / 1000;
  return end - wall_start;
}

void stopwatch_wall_stop_print(void) {
  printf("time %.3fs\n", (double) stopwatch_wall_stop() / 1000);
}

void stopwatch_cpu_start(void){
  cpu_start = clock();
}
time_t stopwatch_cpu_stop(void) {
  return clock() - cpu_start;
}
void stopwatch_cpu_stop_print(void) {
    printf("cpu time %fs\n", (double) stopwatch_cpu_stop() / CLOCKS_PER_SEC);
}
