//
//  strings.c
//  fornax2_core
//
//  Created by Anders on 24/04/2019.
//  Copyright © 2019 Avividi. All rights reserved.
//


#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "strings.h"



int strings_split(char* source, char** dest, const char* delim) {
  int i = 0;
  char *ptr = strtok(source, delim);
  while(ptr != NULL) {
    dest[i] = ptr;
    //    printf("'%s'\n", dest[i]);
    i++;
    ptr = strtok(NULL, delim);
  }
  return i;
}

bool string_equals(const char *s1, const char *s2) {
  return !strcmp(s1, s2);
}

bool string_starts_with(const char *string, const char *prefix) {
  if(strncmp(string, prefix, strlen(prefix)) == 0) return true;
  return false;
}

char *strings_trim(char *str) {
  char *end;
  
  while(isspace((unsigned char)*str)) str++;
  
  if(*str == 0)
    return str;
  
  end = str + strlen(str) - 1;
  while(end > str && isspace((unsigned char)*end)) end--;
  
  end[1] = '\0';
  
  return str;
}

long string_to_long(const char* string) {
  return strtol(string, NULL, 10);
}
