//
//  movepicker.h
//  fornax2_core
//
//  Created by Anders on 21/04/2020.
//  Copyright © 2020 Avividi. All rights reserved.
//

#ifndef movepicker_h
#define movepicker_h

#include "../board/definitions.h"
#include "../board/move.h"
#include "movegen.h"

void movepick_set_killer(uint8_t ply, move m, move ttmove);
void movepick_clean_killers(void);

typedef struct {
  move ttmove;
  move killer1;
  move killer2;
  move moves[256];
  uint8_t movecount;
//  int8_t (*moveValueFunction)(move,move,move);
} Movepick;

void movepick_start(Movepick* state, Board* board, move ttmove);
move movepick_next(Movepick* state);

void movepick_start_quiesce(Movepick* state, Board* board);
move movepick_next_quiesce(Movepick* state);

typedef struct {
  move move;
  eval score;
} RootMove;

typedef struct {
  move ttmove;
  move prevmove;
  move moves[256];
  uint8_t movecount;
  RootMove rootmoves[256];
  uint8_t rootmovecount;
} RootMovePick;

move movepick_root_next(RootMovePick* state);
RootMovePick* movepick_root_list_init(void);
void movepick_root_list_add(RootMovePick* list, move m, eval score);
void movepick_root_list_destroy(RootMovePick* list);
void movepick_root_list_reset(RootMovePick* state, move ttmove);
#endif /* movepicker_h */
