//
//  oracle.h
//  fornax2_core
//
//  Created by Anders on 30.06.2018.
//  Copyright © 2018 Avividi. All rights reserved.
//

#ifndef oracle_h
#define oracle_h

#include "../board/definitions.h"
#include "../board/bitboard.h"

extern bitboard64* oracle_king_attacks;
extern bitboard64* oracle_king_neighbor_vuln_squares;
extern bitboard64* oracle_knight_attacks;
extern bitboard64 (*oracle_sliding_attaks)[64];
extern bitboard64* oracle_castling_dest_and_blocks;
extern bitboard64* oracle_position_to_bitboard;


static inline bitboard64 oracle_get_sliding_attacks(int position, direction dir) {
  return oracle_sliding_attaks[dir][position];
}

static inline bitboard64 oracle_get_knight_attacks(int position) {
  return oracle_knight_attacks[position];
}

static inline bitboard64 oracle_get_king_attacks(int position) {
  return oracle_king_attacks[position];
}

static inline bitboard64 oracle_get_king_neighbor_vuln_squares(int position) {
  return oracle_king_neighbor_vuln_squares[position];
}

static inline bitboard64 oracle_get_castling_blocker(bool isKingSide, bool isWhiteMove) {
  return oracle_castling_dest_and_blocks[4 + (isKingSide << 1) + isWhiteMove];
}

static inline bitboard64 oracle_get_castling_dest(bool isKingSide, bool isWhiteMove) {
  return oracle_castling_dest_and_blocks[(isKingSide << 1) + isWhiteMove];
}

void oracle_init(void);
void oracle_destroy(void);


#endif /* oracle_h */

