//
//  transpositions.h
//  fornax2_core
//
//  Created by Anders on 19/06/2019.
//  Copyright © 2019 Avividi. All rights reserved.
//

#ifndef transpositions_h
#define transpositions_h

#include "../board/definitions.h"

#define TRANSPOSITIONS_SIZE_MB_DEFAULT 128
#define TRANSPOSITIONS_SIZE_PER_MB (64 * 1024)
#define TRANSPOSITIONS_SIZE_MB_MAX (INT32_MAX / (TRANSPOSITIONS_SIZE_PER_MB) - 1)
#define TRANSPOSITIONS_SIZE_MB_MIN 1

typedef struct bucket {
  ttkey hash; //64
//  uint8_t age; //8
  move move; //32
  eval eval; //16
  uint8_t depth; //8
//  tttype type; //8
  uint8_t age_and_type; //8
  //== 128
} Bucket;


static inline tttype transpositions_type(Bucket* b) {
  return b->age_and_type & 0xC0;
}

static inline uint8_t transpositions_age(Bucket* b) {
  return b->age_and_type & 0x3F;
}

void transpositions_init(void);
void transpositions_clear(void);
void transpositions_destroy(void);
void transpositions_maintenance(void);
void transpositions_status(void);
void transpositions_print(long printLength);
void transpositions_print_bucket(ttkey hash, long offset);
void transpositions_set_hash_size(long MB);

void transpositions_put(ttkey hash, uint8_t depth, eval score, move m, tttype type);
Bucket* transpositions_get(ttkey hash);

#endif /* transpositions_h */
