//
//  zobrist.h
//  fornax2_core
//
//  Created by Anders on 19/06/2019.
//  Copyright © 2019 Avividi. All rights reserved.
//

#ifndef zobrist_h
#define zobrist_h

#include "../board/definitions.h"

extern const uint64_t zobrist_numbers[781];

#define ZOBRIST_PIECE(pos, inhabitant, white) (zobrist_numbers[inhabitant * 64 + pos + 64 * 6 * white])
#define ZOBRIST_ENPASSANT(passant) ((0 - (passant > 0)) & zobrist_numbers[64 * 12 + 5 + SQUARE_X(BITBOARD_FIND_TRAILING(passant))])
#define ZOBRIST_WHITE_MOVE() (zobrist_numbers[64 * 12])
#define ZOBRIST_CASTLE_K(white) (zobrist_numbers[64 * 12 + 4 - white - white])
#define ZOBRIST_CASTLE_Q(white) (zobrist_numbers[64 * 12 + 3 - white - white])

ttkey zobrist_piece(square pos, inhabitant inhabitant, bool white);
ttkey zobrist_enpassant(bitboard64 passant);
ttkey zobrist_white_move(void);
ttkey zobrist_castle_q(bool white);
ttkey zobrist_castle_k(bool white);

ttkey zobrist_get(const Board* b);

#endif /* zobrist_h */
